﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.ComponentModel;

namespace BindingDemo
{
    /// <summary>
    /// MainWindow.xaml에 대한 상호 작용 논리
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        private int val;
        public int TestValue
        {
            get { return val; }
            set
            {
                val = value;
                OnPropertyChanged("TestValue");
            }
        }

        public MainWindow()
        {
            InitializeComponent();

             this.DataContext = this;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }
    }

    public class HexConverter : IValueConverter
    {
        public object Convert(object value, Type type, object parameter, System.Globalization.CultureInfo culture)
        {
            int v = (int)value;
            int p = int.Parse((string)parameter);
            return string.Format("0x{0:X" + p.ToString() + "}", v);
        }

        public object ConvertBack(object value, Type type, object parameter, System.Globalization.CultureInfo culture)
        {
            string s = (string)value;
            int v;
            if (int.TryParse(s, System.Globalization.NumberStyles.AllowHexSpecifier, null, out v))
            {
                return v;
            }
            return 0;
        }
    }
}
